﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Drawing;

namespace EduNetworkBuilder
{
    //Holds a little bit of information pertaining to the current animation.
    public class AnimationClass
    {
        Point ImageStartPoint = new Point();
        Rectangle Where;
        Size HowBig; //how big is each animation.
        public DateTime NextAnimation;
        int AnimationCount = 0;
        int AnimationSpeed = 300; //ms between animations
        Image BackgroundSnip;
        int maxAnim = 6;

        public bool AnimationDone { get { if (AnimationCount > 0) return false; return true; } }
        public bool FinalErase = false;

        public AnimationClass(AnimationName What, Rectangle where)
        {
            Where = where;
            switch(What)
            {
                case AnimationName.Fire1:
                    ImageStartPoint = new Point(0,0);
                    HowBig = new Size(100, 100);
                    AnimationCount = 6;
                    break;
                case AnimationName.Smoke1:
                    ImageStartPoint = new Point(0, 100);
                    HowBig = new Size(100, 100);
                    AnimationCount = 6;
                    break;
                case AnimationName.Spark1:
                    ImageStartPoint = new Point(0, 200);
                    HowBig = new Size(100, 100);
                    AnimationCount = 6;
                    break;
            }
        }

        public void GrabBackground(Image TheNetworkImage)
        {
            BackgroundSnip = new Bitmap(Where.Width, Where.Height);
            Graphics.FromImage(BackgroundSnip).DrawImage(TheNetworkImage, new Rectangle(0, 0, Where.Width, Where.Height), Where, GraphicsUnit.Pixel);
        }

        public void DrawAnimation(Image TheNetworkImage)
        {
            Bitmap AnimationFrame  = new Bitmap(Where.Width, Where.Height);
            Rectangle AniminSnip = new Rectangle((maxAnim - AnimationCount) * HowBig.Width, ImageStartPoint.Y, HowBig.Width, HowBig.Height);

            Graphics.FromImage(AnimationFrame).DrawImage(Properties.Resources.Animations, new Rectangle(0, 0, Where.Width, Where.Height), AniminSnip, GraphicsUnit.Pixel);

            Graphics.FromImage(TheNetworkImage).DrawImage(AnimationFrame, new Rectangle(0, 0, Where.Width, Where.Height), Where, GraphicsUnit.Pixel);
        }

        public void EraseAnimation(Image TheNetworkImage)
        {
            Graphics.FromImage(TheNetworkImage).DrawImage(BackgroundSnip, Where, new Rectangle(0,0,Where.Width, Where.Height), GraphicsUnit.Pixel);
        }
    }
}
